import pandas as pd
import numpy as np
from sklearn.metrics.pairwise import cosine_similarity
import operator
from flask_ngrok import run_with_ngrok
from flask import Flask,jsonify,request
import firebase_admin
from firebase_admin import credentials
from firebase_admin import firestore
#from firebase import firebase 

cred = credentials.Certificate("/content/vue-js-teacher-student-firebase-adminsdk-hx2qv-7808c737df.json")
firebase_admin.initialize_app(cred)
db=firestore.client()

marks=pd.read_csv('/content/marks2.csv')
for i in range(1,21):
  marks['q'+str(i)].replace({3:0},inplace=True)

t=pd.DataFrame(marks)
p=t.values
def similar_users(user_id, matrix, k=5):
    # create a df of just the current user
    
    user = matrix[matrix.index == user_id-1]
    print(user)
    # and a df of all other users
    other_users = matrix[matrix.index != user_id-1]
    
    # calc cosine similarity between user and each other user
    similarities = cosine_similarity(user,other_users)[0].tolist()
    
    # create list of indices of these users
    indices = other_users.index.tolist()
    
    # create key/values pairs of user index and their similarity
    index_similarity = dict(zip(indices, similarities))
    
    # sort by similarity
    index_similarity_sorted = sorted(index_similarity.items(), key=operator.itemgetter(1))
    index_similarity_sorted.reverse()
    
    # grab k users off the top
    top_users_similarities = index_similarity_sorted[:k]
    users = [u[0] for u in top_users_similarities]
    
    return users
    
similar_user_indices = similar_users(5,t)
new_list_similaruser = [x+1 for x in similar_user_indices]
print(new_list_similaruser)

def recommend_item(user_index, similar_user_indices, matrix, items=29):
    
    # load vectors for similar users
    similar_users = matrix[matrix.index.isin(similar_user_indices)]
    # calc avg ratings across the 3 similar users
    similar_users = similar_users.mean(axis=0)
    # convert to dataframe so its easy to sort and filter
    similar_users_df = pd.DataFrame(similar_users, columns=['mean'])
    
    
    # load vector for the current user
    user_df = matrix[matrix.index == user_index-1]
    # transpose it so its easier to filter
    user_df_transposed = user_df.transpose()
    # rename the column as 'rating'
    user_df_transposed.columns = ['rating']
    # remove any rows without a 0 value. Anime not watched yet
    user_df_transposed = user_df_transposed[user_df_transposed['rating']==0]
    # generate a list of animes the user has not seen
    animes_unseen = user_df_transposed.index.tolist()
    #print(animes_unseen)
    
    # filter avg ratings of similar users for only anime the current user has not seen
    similar_users_df_filtered = similar_users_df[similar_users_df.index.isin(animes_unseen)]
    #print(similar_users_df_filtered)
    # order the dataframe
    similar_users_df_ordered = similar_users_df_filtered.sort_values(by=['mean'], ascending=True)
    #print(similar_users_df_ordered)
    # grab the top n anime   
    top_n_anime = similar_users_df_ordered.head(items)
    top_n_anime_indices = top_n_anime.index.tolist()
    lst=[]
    lst.append(top_n_anime)
    lst.append(top_n_anime_indices)
    return (lst) #items
# try it out
r=recommend_item(5,similar_user_indices,t)

app = Flask(__name__)
run_with_ngrok(app)

@app.route('/')
def helloworld():
  return 'Hello World!' 

@app.route('/recommend',methods=['POST','GET'])
def recommend():
  result=db.collection('Question numbers').document('selected').get()
  value_to_be_passed=result.to_dict()['Questions']
  #  new= request.get_json()
  #  value_to_passed=new["student_no"]
  response=recommend_item(value_to_be_passed,similar_user_indices,t)[1]
  return jsonify(response)

app.run()
